//********************************************************************
//
//	NOMBRE DEL ARCHIVO:   	cola.h
//	MDULO:			
//	FECHA:			
//	AUTOR:                  Arturo Gil Aparicio//	DESCRIPCIN:
//
//********************************************************************

#ifndef  __COLA_H__
#define  __COLA_H__

//--------------------------------------------------------------------
// Bloque de definiciones  comunes
//--------------------------------------------------------------------
// Definicin de constantes

// Definicin de macros

// Definicin de tipos de datos y clases
#define MAX 25

struct nodoCola{    
    char cadena[MAX];
    struct nodoCola *sig; //puntero al siguiente de la lista
};
typedef struct nodoCola nodoCola;

class CCola{
      private:
              nodoCola *pTopeCola; // Puntero al tope de la cola
              nodoCola *pFondoCola; // Puntero al fondo de la cola
      
      public:
      //CONSTRUCTORES: 
             CCola(void);                      //constructor
             CCola(const CCola &cola_orig);    //constructor copia
             ~CCola(void);                     //destructor

      //SOBRECARGA:  
             CCola& operator = (const CCola &cola_orig);
             CCola operator + (const CCola &cola_orig);

       //METODOS:  
             int InsertarElemento(char* cade);
             char* ExtraerElemento(void);
             
             void MostrarCola(void) const;
             int ColaVacia(void) const;
             int ContarElementos(void) const;
};

//--------------------------------------------------------------------
#ifndef	__COLA_CPP__
//--------------------------------------------------------------------
// Bloque de definiciones externas
// Variables Globales externas
//--------------------------------------------------------------------
#else
//--------------------------------------------------------------------
// Bloque de definiciones internas
// Prototipos de funciones internas
//--------------------------------------------------------------------
#endif		// Fin bloque de definiciones internas
#endif		// Fin bloque de la cabecera
